
package de.ivu.elect.presentation.wahlvorschlag;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.wahlvorschlag.boundary.ListeBoundaryCreate;
import de.ivu.elect.business.wahlvorschlag.entity.Liste;
import de.ivu.elect.business.wahlvorschlag.entity.ListeMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractListeCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractListeCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.LISTE_CREATE)
public abstract class AbstractListeCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<Liste> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "listeCreateView";

  public static final String VIEW_ID = "/wahlvorschlag/liste-create.xhtml";

  public static final String PARENT_VIEW_ID = "/wahlvorschlag/liste-search.xhtml";

  @Inject
  protected transient ListeBoundaryCreate create;

  protected Liste entity;

  @Inject
  protected transient ListeMeta entityMeta;

  
  @PostConstruct
  public void init() {
    setEntity(new  Liste());
  }

  

  public Liste getEntity() {
    return entity;
  }

  protected void setEntity(Liste entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.LISTE_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Liste entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(Liste entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.LISTE_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
